#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ll long long
using namespace std;
using namespace __gnu_pbds;
typedef tree<pair<ll,ll>,null_type,less<>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;
using namespace __gnu_pbds;
void fast_in_out() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
#endif
}
const ll N=1e5;
ll h[N+10],mx[4*N],mod[4*N],s[4*N];
void push(ll v,ll l,ll r) {
    ll m=(l+r)/2;
    if (mod[v]!=-1) {
        mod[2*v]=mod[v],mod[2*v+1]=mod[v];
        mx[2*v]=mod[v],mx[2*v+1]=mod[v];
        s[2*v]=(m-l+1)*mod[v],s[2*v+1]=(r-m)*mod[v];
    }
    mod[v]=-1;
}
void build(ll v,ll l,ll r) {
    if (l==r) {
        mx[v]=h[l];
        mod[v]=-1;
        s[v]=0;
        return;
    }
    ll mid=(l+r)/2;
    build(v*2,l,mid);
    build(v*2+1,mid+1,r);
    mx[v]=max(mx[v],mx[v*2+1]);
    mod[v]=-1;
    s[v]=s[2*v]+s[2*v+1];
}
void upd(ll v,ll l,ll r,ll lx,ll rx,ll x) {
    if (l==lx && r==rx) {
        s[v]=(r-l+1)*x;
        mod[v]=x;
        mx[v]=x;
        return;
    }
    push(v,l,r);
    ll mid=(l+r)/2;
    if (mid<=rx)upd(2*v,l,mid,lx,rx,x);
    else if (mid<lx)upd(2*v+1,mid+1,r,lx,rx,x);
    else
        upd(v*2,l,mid,lx,mid,x),upd(v*2+1,mid+1,r,mid+1,rx,x);
    mx[v]=max(mx[v],mx[v*2+1]);
    s[v]=s[2*v]+s[2*v+1];
}
ll findmx(ll v,ll l,ll r,ll lx,ll rx) {
    if (l==lx && r==rx)return mx[v];
    push(v,l,r);
    ll mid=(l+r)/2;
    if (mid>=rx) return findmx(v*2,l,mid,lx,rx);
    else if (mid<lx) findmx(v*2+1,mid+1,r,lx,rx);
    return max(findmx(v*2,l,mid,lx,mid),findmx(v*2+1,mid+1,r,mid+1,rx));
}
ll findsm(ll v,ll l,ll r,ll lx,ll rx) {
    if (l==lx && r==rx)return s[v];
    push(v,l,r);
    ll mid=(l+r)/2;
    if (mid>=rx) return findmx(v*2,l,mid,lx,rx);
    else if (mid<lx) findmx(v*2+1,mid+1,r,lx,rx);
    return findmx(v*2,l,mid,lx,mid)+findmx(v*2+1,mid+1,r,mid+1,rx);
}
ll n,i,m,k,p[100010];
int main() {
    fast_in_out();
    ordered_set s;
    cin >> n;
    for (i=1;i<=n;i++)cin >> h[i],s.insert({i,i}),p[i]=p[i-1]+h[i];
    build(1,1,n);
    m=n-1;
    while (m--) {
        cin >> k;
        pair<ll,ll> p=*s.order_of_key(k-1);
        s.erase(p);
        pair<ll,ll> q=*s.order_of_key(k-1);
        s.erase(q);
        ll l=p.first-1,r=p.second+1;
        ll mx=findmx(1,1,n,q.first,q.second);
        while (r-l>1) {
            ll mid=(l+r)/2;
            if (findmx(1,1,n,p.first,mid)<=mx) {
                r=mid;
            }else {
                l=mid;
            }
            if (p.first<=l)upd(1,1,n,p.first,l,mx);
        }
        ll l=q.first-1,r=q.second+1;
        ll mx=findmx(1,1,n,q.p,first,p.second);
        while (r-l>1) {
            ll mid=(l+r)/2;
            if (findmx(1,1,n,mid,q.second)<=mx) {
                r=mid;
            }else {
                l=mid;
            }
            if (r<=q.second)upd(1,1,n,r,q.second,mx);
        }
        cout << findsm(1,1,n,p.first,q.second)-(p[q.second]-p[p.first-1]) << "\n";
        s.insert({p.first,q.second});
    }
    return 0;
}